/***************************************
 * AD.c
 *  Created on: 2016323
 *      Author: zhz0828
 ****************************************/


#include <stdio.h>
#include <csl_spi.h>
#include <cslr_spi.h>
#include <csl_sysctrl.h>
#include <csl_general.h>

#define SPI_CMD_write0          (0x8000)            //32ڣ˫ͨ
/**< Error Status to indicate Test has Passed */
#define	SPI_CLK_DIV				(100)
/**< SPI Clock Divisor */
#define	SPI_FRAME_LENGTH		(1)
/**< SPI Frame length */
static Uint16 commandBuf[8];
/** Buffer length used for reading and writing to AD*/
void delay(void);
Int16 SPI_AD_read (CSL_SpiHandle spiHandle,
                       Uint16        src,
                       Uint32        dst,
                       Uint32        length);
void main(void)
 {
    Int16 result;
    CSL_SpiHandle	hSpi;
    SPI_Config	   hwConfig;

    printf("beginning\n\n");
    result = SPI_init();
    if(CSL_SOK == result)
    	{
    		printf ("SPI Instance Initialize successfully\n");
    	}
    hSpi = SPI_open(SPI_CS_NUM_1, SPI_POLLING_MODE);
   	if(NULL != hSpi)
   	{
   		printf ("SPI Instance Opened successfully\n");
   	}
    	CSL_SYSCTRL_REGS->PSRCR = (Uint16)0x04;          //λĴ
   		CSL_SYSCTRL_REGS->PRCR  = (Uint16)0x00FF;        //踴λƼĴ
   		CSL_SYSCTRL_REGS->CCR2=(Uint16)0x0001;
   		CSL_SPI_REGS->SPICDR   = (Uint16)0x00;
   		CSL_SPI_REGS->SPICCR   = (Uint16)0x00;

   		CSL_SPI_REGS->SPIDCR1  = (Uint16)0x0100;         //Ƭѡ1ӳ0ƬѡЧspi2ģʽ
   		CSL_SPI_REGS->SPIDCR2  = (Uint16)0x00;
   		CSL_SPI_REGS->SPICMD1  = (Uint16)0x00;
   		CSL_SPI_REGS->SPICMD2  = (Uint16)0x00;
   		CSL_SPI_REGS->SPISTAT1 = (Uint16)0x00;
   		CSL_SPI_REGS->SPISTAT2 = (Uint16)0x00;
   		CSL_SPI_REGS->SPIDR1   = (Uint16)0x00;
   		CSL_SPI_REGS->SPIDR2   = (Uint16)0x00;
   		/***************************************************************/

   		result = SYS_setEBSR(CSL_EBSR_FIELD_PPMODE,
   	                         CSL_EBSR_PPMODE_1);
   		if (CSL_SOK != result)
   	    {
   	        printf("SYS_setEBSR failed\n");
   	    }

   		CSL_SPI_REGS->SPICCR = (Uint16)(1<<15);                //CLKENʹܣʱʹ


   		/** Set the hardware configuration 							*/
   		hwConfig.spiClkDiv	= SPI_CLK_DIV;                     /*ʱӷƵ*/
   		hwConfig.wLen		= SPI_WORD_LENGTH_16,	              /*ַΪ16*/
   		hwConfig.frLen		= SPI_FRAME_LENGTH;                /*֡Ϊ64*/
   		hwConfig.wcEnable	= SPI_WORD_IRQ_DISABLE;             /*spiַжʹ*/
   		hwConfig.fcEnable	= SPI_FRAME_IRQ_DISABLE;           /*spi֡жΪdisable*/
   		hwConfig.csNum		= SPI_CS_NUM_1;                    /*adƬѡźΪcs1*/
   		hwConfig.dataDelay	= SPI_DATA_DLY_0;                  /*ӳٲ̫λ0*/
   		hwConfig.csPol		= SPI_CSP_ACTIVE_LOW;              /* SPI clock polarity low */
   		hwConfig.clkPol		=  SPI_CLKP_HIGH_AT_IDLE;            /* SPI chip select polarity low */
   		hwConfig.clkPh		= SPI_CLK_PH_FALL_EDGE;            /*spiʱλΪ½*/
   		/*************************************************************************************/

   		result = SPI_config(hSpi, &hwConfig);

   		if(CSL_SOK != result)
   		{
   			printf ("SPI Instance Configuration Failed\n");
   		}
   		else
   		{
   			printf ("SPI Instance Configured successfully\n");
   		}
   	    result = SPI_deInit();
   	    	if(CSL_SOK == result)
   	    	{
   	    		printf ("SPI Instance deIntialize successfully\n");
   	    	}

   	    	result = SPI_close(hSpi);
   	    	if(CSL_SOK == result)
   	    	{
   	    		printf ("SPI Instance Close successfully\n");
   	    	}
    }


Int16 SPI_AD_read(CSL_SpiHandle spiHandle, Uint16 src, Uint32 dst, Uint32 length )
{
    CSL_Status result;
	result = CSL_SOK;
    Uint16     *dst_ptr;

	CSL_SPI_REGS->SPICCR = (Uint16)(1<<15);
	CSL_SPI_REGS->SPICMD1 = (Uint16)0x0000 | 1;
	CSL_SPI_REGS->SPICMD2 = (Uint16)0x107B;

	commandBuf[0] = (Uint16)SPI_CMD_write0;
	result |= SPI_write(spiHandle, commandBuf, 1);

	while(1)
	{
		dst_ptr = (Uint16 *)dst;
		result |= SPI_read(spiHandle, dst_ptr, 1);
		delay();
	}
}


void delay(void)
{
	  unsigned long delay;
	  delay= 500000;
	  for(;delay>0;delay--){};
}
